<template>
<div class="app">
  <div class="container-fluid tamaño">
    <div class="container"><br>
      <div class="row">
        <div class="col s12 m3"></div>
        <div class="col s12 m12">
          <div class="card-content white-text">
            <div class="input-field col s12 m6">
              <input id="text_buscar" type="text" class="validate" v-model="search">
              <label for="text_buscar">Ingrese un titulo</label>
              <button class="btn lime darken-4" type="submit" name="btn_buscar" @click.prevent="searchMovie">
                Buscar
              </button>
            </div>
            <div class="input-field col s12 m6">
              <select name="filtros" @change="getMovies()" v-model="selected">
                <optgroup label="Opciones">
                  <option value="0" selected>Mas populares</option>
                  <option value="1">Mejor calificadas</option>
                  <option value="2">Infantiles más populares</option>
                  <option value="3">Mejores dramas</option>
                </optgroup>
              </select>
              <label>Filtrar</label>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row center-align" v-show="!moviesSearch">
      <div class="col s12 m6 l4 xl3" v-for="(movie, key) in movies" :key="movie.id">
        <div class="card tarjeta">
          <div class="card-image">
            <img :alt="movie.original_title" :src="src+movie.poster_path">
            <span class="card-title" id="imagen">{{movie.original_title}}</span>
          </div>
          <div class="card-content">
            <p>{{movie.overview | excep}}</p>
            <div class="container">
              <label>Rating</label><br>
              <span class="card-title">{{movie.popularity}}</span>
            </div>
          </div>
          <div class="card-action">
            <router-link :to="{name: 'movie.details',  params: { id: movie.id} }">
              <span class="detalles-texto">Detalles</span>
            </router-link>
          </div>
        </div>
      </div>
      <router-view></router-view>
    </div>
    <div class="row center-align" v-show="moviesSearch">
      <div class="col s12 m6 l4 xl3" v-for="(movieSearch, keySearch) in moviesSearch" :key="movieSearch.id">
        <div class="card tarjeta">
          <div class="card-image">
            <img :alt="movieSearch.original_title" :src="src+movieSearch.poster_path">
            <span class="card-title" id="imagen">{{movieSearch.original_title}}</span>
          </div>
          <div class="card-content">
            <p>{{movieSearch.overview | excep}}</p>
            <div class="container">
              <label>Rating</label><br>
              <span class="card-title">{{movieSearch.popularity}}</span>
            </div>
          </div>
          <div class="card-action">
            <router-link :to="{name: 'movie.details',  params: { id: movieSearch.id} }">
              Detalles
            </router-link>
          </div>
        </div>
      </div>
      <router-view></router-view>
    </div>
  </div>
  <div class="row">
    <div class="col s12 m3 l3 xl4"></div>
    <div class="col s12 m6 l6 xl4">
      <sliding-pagination :current="page" :total="total_pages" @page-change="pageChangeHandler" class="lime darken-2"></sliding-pagination>
    </div>
  </div>
</div>
</template>
<script type="text/javascript">
import SlidingPagination from 'vue-sliding-pagination';
import axios from 'axios';
const API_KEY = '64d3b4ea4aba69ef82011e7ba6318123';
const BASE = 'https://api.themoviedb.org/3';

export default {
  data() {
    return {
      movies: null,
      moviesSearch: null,
      src: 'https://image.tmdb.org/t/p/w185_and_h278_bestv2',
      page: 1,
      total_pages: 0,
      selected: 0,
      search: ''
    }
  },
  components: {
    SlidingPagination
  },
  mounted() {
    this.getMovies();
  },
  filters: {
    excep(value) {
      return value.substring(0, 30) + '...';
    },
  },
  methods: {
    getMovies() {
      let URL;
      switch (Number.parseInt(this.selected)) {
        case 0:
          URL = `${BASE}/discover/movie?sort_by=popularity.desc&api_key=${API_KEY}&page=${this.page}&language=es-sv`;
          break;
        case 1:
          URL = `${BASE}/discover/movie/?certification_country=US&certification=R&sort_by=vote_average.desc&api_key=${API_KEY}&page=${this.page}&language=es-sv`;
          break;
        case 2:
          URL = `${BASE}/discover/movie?certification_country=US&certification.lte=G&sort_by=popularity.asc&api_key=${API_KEY}&page=${this.page}&language=es-sv`;
          break;
        case 3:
          URL = `${BASE}/discover/movie?with_genres=18&primary_release_year=2020&api_key=${API_KEY}&page=${this.page}&language=es-sv`;
          break;
      }
      axios
        .get(URL)
        .then(response => {
          this.total_pages = response.data.total_pages;
          this.movies = response.data.results.filter(item => item.poster_path !== null);
        })
        .catch(error => {
          console.error(error);
          throw error;
        }); //.catch(error => { console.error(error); return Promise.reject(error); })
    },
    searchMovie() {
      const URL = `${BASE}/search/movie?api_key=${API_KEY}&query=${this.search}`;
      axios
        .get(URL)
        .then(response => {
          this.total_pages = response.data.total_pages;
          this.moviesSearch = response.data.results.filter(item => item.poster_path !== null);
        })
        .catch(error => {
          console.error(error);
          throw error;
        }); //  ${this.search} .catch(error => { console.error(error); return Promise.reject(error); })
    },
    pageChangeHandler(selectedPage) {
      this.page = selectedPage
      this.getMovies();
    },
  },
};
</script>
<style>
.c-sliding-pagination {
  text-align: center;
  margin: 1.5em 0;
}

.NotFound {
  display: flex;
  justify-content: center;
  margin-top: 90px;
  margin-left: auto;
  margin-right: auto;
}

@media screen and (max-width: 600px) {
  .tamaño {
    width: 70%;
    margin-left: auto;
    margin-right: auto;
  }

  #fijacion {
    margin-top: 85px;
  }

  .NotFound {
    display: flex;
    justify-content: center;
    margin-top: 90px;
    margin-left: auto;
    margin-right: auto;
  }
}

@media screen and (min-width: 600px) and (max-width: 993px) {
  .tamaño {
    width: 80%;
    margin-left: auto;
    margin-right: auto;
  }

  #fijacion {
    margin-top: 85px;
  }

  .NotFound {
    display: flex;
    justify-content: center;
    margin-top: 90px;
    margin-left: auto;
    margin-right: auto;
  }
}

@media screen and (min-width: 993px) {
  .tamaño {
    width: 95%;
    margin-left: auto;
    margin-right: auto;
  }

  #fijacion {
    margin-top: 85px;
  }

  .NotFound {
    display: flex;
    justify-content: center;
    margin-top: 90px;
    margin-left: auto;
    margin-right: auto;
  }
}

.tarjeta {
  /*height: 740px;*/
  height: auto;
  margin-left: auto;
  margin-right: auto;
}

#imagen {
  font-weight: bolder;
  text-shadow: -1px 0 #ffffff, 1px 0 #ffffff, 0 1px #ffffff, 0 -1px #ffffff;
  color: #0b0000;
}

.detalles-texto {
  color: #827717;
  font-weight: bolder;
}

.perfil {
  margin-top: 100px;
  margin-bottom: 100px;
}
</style>
